<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Objetos Angel Navarrete</title>
</head>
<body>
    <h1>TVSamsung</h1>
    <script>
        var tvSamsung = {
            nombre: "TV Samsung 42'",
            categoria: "Televisores",
            unidades: 4,
            precio: 345.95,
            getImporte(){
                return "Valor de las unidades: " + this.unidades*this.precio;
            }
            //getImporte: function(){
            //    return "Valor de las unidades: " + this.unidades*this.precio;
            //}
        };
        //Al objeto tvSamsung añadele iterativamente varias características y que sea al usuario quien indique el valor.
        propiedad = "pulgadas";
        let valor = prompt("Introduce las pulgadas");
        tvSamsung[propiedad]=valor;

        propiedad = "gama";
        let valor2 = prompt("Introduce la gama");
        tvSamsung[propiedad]=valor2;

        propiedad = "numeroHDMI";
        let valor3 = prompt("Introduce el numero de HDMI");
        tvSamsung[propiedad]=valor3;

        //Crea una lista de propiedades que crees que debería tener un televisor y comprueba si tvSamsung las tiene o no. En caso de no tenerlas añadela e inicializarla a undefined.
        tvSamsung["resolucion"]=undefined ;
        tvSamsung["color"]=undefined ;
        tvSamsung["calidad"]=undefined ;
        tvSamsung["sonido"]=undefined ;
        tvSamsung["smartTV"]=undefined ;
        
        //Muestra en un página HTML toda la información relativa a tvSamsung.
        function crearPaginaHTMLDeObjeto(obj){
            for (var p in obj) {
                var pHTML = document.createElement("p");
                var pHTMLInfo = document.createTextNode(`${p} = ${obj[p]}\n`);
                pHTML.appendChild(pHTMLInfo);
                document.body.appendChild(pHTML);
            }
        }
        crearPaginaHTMLDeObjeto(tvSamsung);

        function MostrarTvSamsung(obj) {
            var result = ``;
            for (var p in obj) {
                    result += `${p} = ${obj[p]}\n`;
            }
            return result;
        }
        //console.log(tvSamsung);

        //console.log(MostrarTvSamsung(tvSamsung));
        //console.log(tvSamsung.getImporte());

        //Obtén el string que corresponde al JSON de tvSamsung.
        function ObjectToJSON(tvSamsung){
            let jsontvSamsung = JSON.stringify(tvSamsung);
            console.log(jsontvSamsung);
            return jsontvSamsung;
        }
        let jsonAlumno = ObjectToJSON(tvSamsung);
        //Haz el proceso inverso y recupera el objeto. Muestra los datos.
        function JSONtoObject(jsonAlumno){
            let a = JSON.parse(jsonAlumno);
            console.log(typeof(a) +" --> " + a);  //object --> [object Object]

            //Visualizamos toda la información que hay en el Objeto.
            for (const key in a) {
                console.log(`${key} = ${a[key]}`);
            }

        }
        JSONtoObject(jsonAlumno);


    </script>
</body>
</html>